/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: Service.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */
#ifndef OpenSOAP_Service_H
#define OpenSOAP_Service_H

#include <OpenSOAP/Envelope.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

    typedef struct tagOpenSOAPService OpenSOAPService;
    typedef OpenSOAPService    *OpenSOAPServicePtr;

    typedef
    int
    (*OpenSOAPServiceFuncPtr)(/* [in]  */ OpenSOAPEnvelopePtr request,
                              /* [out] */ OpenSOAPEnvelopePtr *response,
                              /* [in, out] */ void *opt);

    int
    OPENSOAP_API
    OpenSOAPServiceCreateMB(/* [out] */ OpenSOAPServicePtr *srv,
                            /* [in]  */ const char *srv_name,
                            /* [in]  */ const char *connect_type,
                            /* [in]  */ int is_loop,
                            ...);

    int
    OPENSOAP_API
    OpenSOAPServiceCreateWC(/* [out] */ OpenSOAPServicePtr *srv,
                            /* [in]  */ const wchar_t *srv_name,
                            /* [in]  */ const char *connect_type,
                            /* [in]  */ int is_loop,
                            ...);

    int
    OPENSOAP_API
    OpenSOAPServiceRelease(/* [in, out] */ OpenSOAPServicePtr srv);
    
    int
    OPENSOAP_API
    OpenSOAPServiceRegisterMB(/* [in, out] */ OpenSOAPServicePtr srv,
                              /* [in] */ const char *name,
                              /* [in] */ OpenSOAPServiceFuncPtr func,
                              /* [in] */ void *opt);

    int
    OPENSOAP_API
    OpenSOAPServiceRegisterWC(/* [in, out] */ OpenSOAPServicePtr srv,
                              /* [in] */ const wchar_t *name,
                              /* [in] */ OpenSOAPServiceFuncPtr func,
                              /* [in] */ void *opt);

    int
    OPENSOAP_API
    OpenSOAPServiceRun(/* [in, out] */ OpenSOAPServicePtr srv);
    
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* OpenSOAP_Service_H */
