# -----------------------------------------------------------------------------
#  $RCSfile: Calc.mak,v $
# 
#  See Copyright for the status of this software.
# 
#  The OpenSOAP Project
#  http://opensoap.jp/
# -----------------------------------------------------------------------------

# MS SOAP Variables
# SOAPAction HTTP header CalcService Prefix
CALC_SOAPACTION_PREFIX = http://tempuri.org/action/Calc
# MS SOAP Toolkit executable service hostname
MSSOAPSAMPLESERVER = MSSoapSampleServer
#MSSOAPSAMPLESERVER = localhost

#
prefix=/usr/local
bindir=$(prefix)/bin
sbindir=$(prefix)/sbin
#sysconfdir=$(prefix)/etc
#localstatedir=$(prefix)/var
CGI_BIN_DIR=/home/httpd/cgi-bin
#CGI_BIN_DIR=/var/www/cgi-bin
#CGI_BIN_DIR=/usr/local/apache2/cgi-bin
#CGI_BIN_DIR=/usr/lib/cgi-bin
#
INSTALL = install -c
INSTALL_PROGRAM = $(INSTALL)
INSTALL_DATA = $(INSTALL) -m 0644
INSTALL_SCRIPT = $(INSTALL_PROGRAM)
# 
OPENSOAP_PREFIX=$(prefix)
OPENSOAP_SYSCONFDIR=/var/tmp/OpenSOAP
OPENSOAP_LOCALSTATEDIR=/var/tmp/OpenSOAP
SSML_DIR=$(OPENSOAP_SYSCONFDIR)/conf/ssml

# use libiconv
#ICONV_LIBS=-liconv

#
console_client_PROGRAMFILES = CalcClient

#
cgi_service_PROGRAMFILES = CalcService.cgi
#
stdio_service_PROGRAMFILES = CalcService
SSML_FILES = Calc.ssml

#
PROGRAMS = \
	$(console_client_PROGRAMFILES) \
	$(cgi_client_PROGRAMFILES) \
	$(stdio_service_PROGRAMFILES) \
	$(cgi_service_PROGRAMFILES)

XML2_LIBS=`xml2-config --libs`

COMMON_LIBS=$(XML2_LIBS) $(ICONV_LIBS)
#
OPENSOAP_INCLUDE=$(OPENSOAP_PREFIX)/include
OPENSOAP_LIB=$(OPENSOAP_PREFIX)/lib

#
CFLAGS= -I$(OPENSOAP_INCLUDE)
# CFLAGS=-g -I$(OPENSOAP_INCLUDE)
CGI_CFLAGS=$(CFLAGS) -DCONNECT_TYPE=\"cgi\"

COMMON_LDFLAGS=-L$(OPENSOAP_LIB) -Wl,-rpath -Wl,$(OPENSOAP_LIB)
#COMMON_LDFLAGS=-L$(OPENSOAP_LIB) -R$(OPENSOAP_LIB)
CLIENT_LDFLAGS=$(COMMON_LDFLAGS) -lOpenSOAPClient $(COMMON_LIBS)
SERVICE_LDFLAGS=$(COMMON_LDFLAGS) -lOpenSOAPService -lOpenSOAPClient $(COMMON_LIBS)

SOURCES = CalcApp.c CalcClient.c CalcService.c
OBJS=$(SOURCES:.c=.o) CalcService.cgi.o CalcClient.cgi.o


all: $(PROGRAMS)


## Make Client Programs

CalcClient: CalcClient.o
	$(CC) -o $@ $^ $(CLIENT_LDFLAGS)

CalcApp.cgi: CalcClient.cgi.o CalcApp.o 
	$(CC) -o $@ $^ $(CLIENT_LDFLAGS)

CalcClient.cgi.o: CalcClient.c
	$(CC) $(CLIENT_CGI_CFLAGS) -c -o $@ $^


## Make Service Programs

CalcService: CalcService.o
	$(CC)  -o $@ $^ $(SERVICE_LDFLAGS)

CalcService.cgi: CalcService.cgi.o
	$(CC)  -o $@ $^ $(SERVICE_LDFLAGS)

CalcService.cgi.o: CalcService.c
	$(CC) $(CGI_CFLAGS) -c -o $@ $<


## Install Programs

#
console-client-install: $(console_client_PROGRAMFILES)
	@if test -d $(DESTDIR)$(bindir); then \
		echo "$(DESTDIR)$(bindir) exist."; \
	else \
		echo "$(DESTDIR)$(bindir) does not exist."; \
		echo "mkdir -p $(DESTDIR)$(bindir)."; \
		mkdir -p $(DESTDIR)$(bindir); \
	fi
	@for f in $^ ; do \
		echo "$$f install to $(bindir)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(bindir)/$$f; \
	done

#
client-install: console-client-install

#
ssml-install: $(SSML_FILES)
	@if test -d $(DESTDIR)$(SSML_DIR); then \
		echo "$(DESTDIR)$(SSML_DIR) exist."; \
	else \
		echo "mkdir -p $(DESTDIR)$(SSML_DIR)."; \
		mkdir -p $(DESTDIR)$(SSML_DIR); \
	fi
	@for f in $^ ; do \
		echo "$$f install to $(SSML_DIR)."; \
		$(INSTALL_DATA) \
			$$f $(DESTDIR)$(SSML_DIR)/$$f; \
	done

stdio-service-programs-install: $(stdio_service_PROGRAMFILES)
	@if test -d $(DESTDIR)$(sbindir); then \
		echo "$(DESTDIR)$(sbindir) exist."; \
	else \
		echo "$(DESTDIR)$(sbindir) does not exist."; \
		echo "mkdir -p $(DESTDIR)$(sbindir)."; \
		mkdir -p $(DESTDIR)$(sbindir); \
	fi
	@for f in $^ ; do \
		echo "$$f install to $(sbindir)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(sbindir)/$$f; \
	done

stdio-service-install: stdio-service-programs-install ssml-install

#
cgi-service-install: $(cgi_service_PROGRAMFILES)
	@if test -d $(DESTDIR)$(CGI_BIN_DIR); then \
		echo "$(DESTDIR)$(CGI_BIN_DIR) exist."; \
	else \
		echo "$(DESTDIR)$(CGI_BIN_DIR) does not exist."; \
		echo "mkdir -p $(DESTDIR)$(CGI_BIN_DIR)."; \
		mkdir -p $(DESTDIR)$(CGI_BIN_DIR); \
	fi
	@for f in $^ ; do \
		echo "$$f install to $(CGI_BIN_DIR)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(CGI_BIN_DIR)/$$f; \
	done

service-install: cgi-service-install stdio-service-install ssml-install

#
sample-install: client-install service-install

## Install Service Programs

install: service-install

## clean
clean: 
	rm -f $(OBJS) $(PROGRAMS)

## Client test

ctest1:
	./CalcClient -s http://$(MSSOAPSAMPLESERVER)/MSSoapSamples/Calc/Service/SrSz/AspJsCpp/Calc.asp -a $(CALC_SOAPACTION_PREFIX).Add 10 + 20

ctest2:
	./CalcClient -s http://$(MSSOAPSAMPLESERVER)/MSSoapSamples/Calc/Service/SrSz/AspJsCpp/Calc.asp -a $(CALC_SOAPACTION_PREFIX).Subtract 10 - 20

ctest3:
	./CalcClient -s http://$(MSSOAPSAMPLESERVER)/MSSoapSamples/Calc/Service/SrSz/AspJsCpp/Calc.asp -a $(CALC_SOAPACTION_PREFIX).Multiply 10 x 20

ctest4:
	./CalcClient -s http://$(MSSOAPSAMPLESERVER)/MSSoapSamples/Calc/Service/SrSz/AspJsCpp/Calc.asp -a $(CALC_SOAPACTION_PREFIX).Devide 10 / 20

