# -----------------------------------------------------------------------------
#   $RCSfile: CalcAsync.mak,v $
#  
#   See Copyright for the status of this software.
#  
#   The OpenSOAP Project
#   http://opensoap.jp/
# -----------------------------------------------------------------------------
#
prefix=/usr/local
bindir=$(prefix)/bin
sbindir=$(prefix)/sbin
#sysconfdir=$(prefix)/etc
#localstatedir=$(prefix)/var
CGI_BIN_DIR=/home/httpd/cgi-bin
#CGI_BIN_DIR=/var/www/cgi-bin
#CGI_BIN_DIR=/usr/local/apache2/cgi-bin
#CGI_BIN_DIR=/usr/lib/cgi-bin
#
INSTALL_PROGRAM=install -c
# 
OPENSOAP_PREFIX=$(prefix)
OPENSOAP_SYSCONFDIR=/var/tmp/OpenSOAP
OPENSOAP_LOCALSTATEDIR=/var/tmp/OpenSOAP
SSMLDIR=$(OPENSOAP_SYSCONFDIR)/conf/ssml

# use libiconv
#ICONV_LIBS=-liconv

#
console_client_PROGRAMFILES = CalcAsyncClient
#
cgi_client_PROGRAMFILES = CalcAsyncApp.cgi
CLIENT_HTML_DIR = CalcAsyncHtml
CLIENT_HTML_FILES = \
	$(CLIENT_HTML_DIR)/AcceptedFooter.html \
	$(CLIENT_HTML_DIR)/AcceptedHeader.html \
	$(CLIENT_HTML_DIR)/CommonFooter.html \
	$(CLIENT_HTML_DIR)/CommonHeader.html \
	$(CLIENT_HTML_DIR)/ErrorFooter.html \
	$(CLIENT_HTML_DIR)/ErrorHeader.html \
	$(CLIENT_HTML_DIR)/RequestFooter.html \
	$(CLIENT_HTML_DIR)/RequestHeader.html \
	$(CLIENT_HTML_DIR)/ResultFooter.html \
	$(CLIENT_HTML_DIR)/ResultHeader.html

#
cgi_service_PROGRAMFILES = CalcAsyncService.cgi
#
stdio_service_PROGRAMFILES = CalcAsyncService
SSML_FILES = CalcAsync.ssml

#
PROGRAMS = \
	$(console_client_PROGRAMFILES) \
	$(cgi_client_PROGRAMFILES) \
	$(stdio_service_PROGRAMFILES) \
	$(cgi_service_PROGRAMFILES)

XML2_LIBS=`xml2-config --libs`

COMMON_LIBS=$(XML2_LIBS) $(ICONV_LIBS)
#
OPENSOAP_INCLUDE=$(OPENSOAP_PREFIX)/include
OPENSOAP_LIB=$(OPENSOAP_PREFIX)/lib

#
CFLAGS= -I$(OPENSOAP_INCLUDE)
# CFLAGS=-g -I$(OPENSOAP_INCLUDE)
CGI_CFLAGS=$(CFLAGS) -DCONNECT_TYPE_CGI
CLIENT_CGI_CFLAGS=$(CFLAGS) -DCLIENT_CGI

COMMON_LDFLAGS=-L$(OPENSOAP_LIB) -Wl,-rpath -Wl,$(OPENSOAP_LIB)
#COMMON_LDFLAGS=-L$(OPENSOAP_LIB) -R$(OPENSOAP_LIB)
CLIENT_LDFLAGS=$(COMMON_LDFLAGS) -lOpenSOAPClient $(COMMON_LIBS)
SERVICE_LDFLAGS=$(COMMON_LDFLAGS) -lOpenSOAPService -lOpenSOAPClient $(COMMON_LIBS)

SOURCES = CalcAsyncApp.c CalcAsyncClient.c CalcAsyncService.c
OBJS=$(SOURCES:.c=.o) CalcAsyncService.cgi.o CalcAsyncClient.cgi.o


all: $(PROGRAMS)


## Make Client Programs

CalcAsyncClient: CalcAsyncClient.o
	$(CC) -o $@ $^ $(CLIENT_LDFLAGS)

CalcAsyncApp.cgi: CalcAsyncClient.cgi.o CalcAsyncApp.o 
	$(CC) -o $@ $^ $(CLIENT_LDFLAGS)

CalcAsyncClient.cgi.o: CalcAsyncClient.c
	$(CC) $(CLIENT_CGI_CFLAGS) -c -o $@ $^


## Make Service Programs

CalcAsyncService: CalcAsyncService.o
	$(CC)  -o $@ $^ $(SERVICE_LDFLAGS)

CalcAsyncService.cgi: CalcAsyncService.cgi.o
	$(CC)  -o $@ $^ $(SERVICE_LDFLAGS)

CalcAsyncService.cgi.o: CalcAsyncService.c
	$(CC) $(CGI_CFLAGS) -c -o $@ $<


## Install Programs

#
console-client-install: $(console_client_PROGRAMFILES)
	@if test -d $(DESTDIR)$(bindir); then \
		echo "$(DESTDIR)$(bindir) exits."; \
	else \
		echo "$(DESTDIR)$(bindir) does not exit."; \
		echo "mkdir -p $(DESTDIR)$(bindir)."; \
		mkdir -p $(DESTDIR)$(bindir); \
	fi
	for f in $^ ; do \
		echo "$$f install to $(bindir)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(bindir); \
	done

cgi-client-programs-install: $(cgi_client_PROGRAMFILES)
	@if test -d $(DESTDIR)$(CGI_BIN_DIR); then \
		echo "$(DESTDIR)$(CGI_BIN_DIR) exits."; \
	else \
		echo "$(DESTDIR)$(CGI_BIN_DIR) does not exit."; \
		echo "mkdir -p $(DESTDIR)$(CGI_BIN_DIR)."; \
		mkdir -p $(DESTDIR)$(CGI_BIN_DIR); \
	fi
	for f in $^ ; do \
		echo "$$f install to $(CGI_BIN_DIR)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(CGI_BIN_DIR); \
	done

cgi-client-datas-install: $(CLIENT_HTML_FILES)
	@if test -d $(DESTDIR)$(CGI_BIN_DIR); then \
		echo "$(DESTDIR)$(CGI_BIN_DIR) exits."; \
	else \
		echo "$(DESTDIR)$(CGI_BIN_DIR) does not exit."; \
		echo "mkdir -p $(DESTDIR)$(CGI_BIN_DIR)."; \
		mkdir -p $(DESTDIR)$(CGI_BIN_DIR); \
	fi
	cp -r $(CLIENT_HTML_DIR) $(DESTDIR)$(CGI_BIN_DIR)

cgi-client-install: cgi-client-programs-install cgi-client-datas-install
#
client-install: console-client-install cgi-client-install

#
ssml-install: $(SSML_FILES)
	@if test -d $(DESTDIR)$(SSMLDIR); then \
		echo "$(DESTDIR)$(SSMLDIR) exits."; \
	else \
		echo "mkdir -p $(DESTDIR)$(SSMLDIR)."; \
		mkdir -p $(DESTDIR)$(SSMLDIR); \
	fi
	for f in $^ ; do \
		echo "$$f install to $(SSMLDIR)."; \
		cp $$f $(DESTDIR)$(SSMLDIR); \
	done

stdio-service-programs-install: $(stdio_service_PROGRAMFILES)
	@if test -d $(DESTDIR)$(sbindir); then \
		echo "$(DESTDIR)$(sbindir) exits."; \
	else \
		echo "$(DESTDIR)$(sbindir) does not exit."; \
		echo "mkdir -p $(DESTDIR)$(sbindir)."; \
		mkdir -p $(DESTDIR)$(sbindir); \
	fi
	for f in $^ ; do \
		echo "$$f install to $(sbindir)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(sbindir); \
	done

stdio-service-install: stdio-service-programs-install ssml-install

#
cgi-service-install: $(cgi_service_PROGRAMFILES)
	@if test -d $(DESTDIR)$(CGI_BIN_DIR); then \
		echo "$(DESTDIR)$(CGI_BIN_DIR) exits."; \
	else \
		echo "$(DESTDIR)$(CGI_BIN_DIR) does not exit."; \
		echo "mkdir -p $(DESTDIR)$(CGI_BIN_DIR)."; \
		mkdir -p $(DESTDIR)$(CGI_BIN_DIR); \
	fi
	for f in $^ ; do \
		echo "$$f install to $(CGI_BIN_DIR)."; \
		$(INSTALL_PROGRAM) \
			$$f $(DESTDIR)$(CGI_BIN_DIR); \
	done

service-install: cgi-service-install stdio-service-install ssml-install

#
sample-install: client-install service-install

## Install Client and Service Programs

install: cgi-client-install service-install

## clean
clean: 
	rm -f $(OBJS) $(PROGRAMS)


## Test Service Programs for Success Cases

stest1:
	cat CalcAsyncSampleMessages/CalcAsyncAdd.xml | ./CalcAsyncService.cgi
stest2:	    
	cat CalcAsyncSampleMessages/CalcAsyncSubtract.xml | ./CalcAsyncService.cgi
stest3:	    
	cat CalcAsyncSampleMessages/CalcAsyncMultiply.xml | ./CalcAsyncService.cgi
stest4:	    
	cat CalcAsyncSampleMessages/CalcAsyncDivide.xml | ./CalcAsyncService.cgi


## Test Client-Service Hookups for Success Cases

ctest1:
	./CalcAsyncClient -s http://localhost/cgi-bin/CalcAsyncService.cgi -c EUC-JP Add 10 20
ctest2:
	./CalcAsyncClient -s http://localhost/cgi-bin/CalcAsyncService.cgi -c EUC-JP Subtract 10 20
ctest3:
	./CalcAsyncClient -s http://localhost/cgi-bin/CalcAsyncService.cgi -c EUC-JP Multiply 10 20
ctest4:
	./CalcAsyncClient -s http://localhost/cgi-bin/CalcAsyncService.cgi -c EUC-JP Divide 10 20


## Test Client-Server-Service Hookups for Sync/Async Success Cases

cstest1:
	./CalcAsyncClient -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP Add 10 20
cstest1a:
	./CalcAsyncClient -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP AddAsync 10 20 > tmp_msg

cstest2:
	./CalcAsyncClient -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP Subtract 10 20
cstest2a:
	./CalcAsyncClient -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP SubtractAsync 10 20 > tmp_msg

cstest3:
	./CalcAsyncClient -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP Multiply 10 20
cstest3a:
	./CalcAsyncClient -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP MultiplyAsync 10 20 > tmp_msg

cstest4:
	./CalcAsyncClient -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP Divide 10 20
cstest4a:
	./CalcAsyncClient -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP DivideAsync 10 20 > tmp_msg

cstestr:
	cat tmp_msg | ./CalcAsyncClient -s http://localhost/cgi-bin/soapInterface.cgi -c EUC-JP GetResult
