/*-----------------------------------------------------------------------------
 * $RCSfile: wmemmove.c,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */


#include <stdlib.h>

extern
wchar_t *
wmemmove(wchar_t *dest,
         const wchar_t *src,
         size_t n) {
    if (dest && src) {
        wchar_t *d = dest;
        if (dest > src) {
            const wchar_t *s = src + n;
            d += n;
            for (; n; --n) {
                *(--d) = *(--s);
            }
        }
        else if (dest < src) {
            for (; n; --n) {
                *d++ = *src++;
            }
        }
    }
    
    return dest;
}
